if(isFile("Add-Ons/System_ReturnToBlockland/client.cs"))
{
	if($RTB::Version $= "")
		exec("Add-Ons/System_ReturnToBlockland/client.cs");
}
else
{
	error("Script_BetterPrefs requires RTB!");
	return;
}

exec("./support.cs");

if(isObject(BpManagerGui))
	BpManagerGui.delete();

exec("./BpManagerGui.gui");

if(isObject(BpPrefTemplate))
	BpPrefTemplate.delete();

exec("./BpPrefTemplate.gui");

// hacky: find the rtb preferences tab button

$CBpRtbPrefsCmd = "RTB_ServerControl.setTab(3);";

function BpFindRtbPrefsBtn()
{
	$CBpRtbPrefsBtn = RTB_ServerControl.getObject(0).getObject(2);

	if(trim($CBpRtbPrefsBtn.command) !$= $CBpRtbPrefsCmd)
	{
		%window = RTB_ServerControl.getObject(0);
		%cts = %window.getCount();
		for(%i = 0; %i < %cts; %i++)
		{
			%obj = %window.getObject(%i);

			if(trim(%obj.command) $= $CBpRtbPrefsCmd)
			{
				$CBpRtbPrefsBtn = %obj;
				return true;
			}
		}
	}

	error("BpFindRtbPrefsBtn() - Preferences button not found!");
	return;
}

BpFindRtbPrefsBtn();

function CBp()
{
	BpCleanup();
	exec("./client.cs");
}

function BpStripCategory(%name)
{
	%strip = trim(getSubStr(strchr(%name, "-"), 1, 256));

	if(%strip $= "")
	{
		%strip = trim(getSubStr(strchr(%name, "|"), 1, 256));

		if(%strip $= "")
			return %name;
	}

	return %strip;
}

function clientCmdBpRegisterPref(%a, %b, %c, %d, %e, %def, %val)
{
	%data = %a @ %b @ %c @ %d @ %e;

	// * %name TAB %pref TAB %cat TAB %vartype TAB %mod TAB %requiresRestart TAB %hostOnly TAB %callback

	// %name = getField(%data, 0);
	%pref = getField(%data, 1);
	// %cat  = getField(%data, 2);
	// %type = getField(%data, 3);
	%mod  = getField(%data, 4);
	// %rest = getField(%data, 5);
	// %host = getField(%data, 6);
	// %call = getField(%data, 7);

	if($BpPrefMods $= "")
		$BpPrefMods = 0;

	if($BpPrefs $= "")
		$BpPrefs = 0;

	if($BpPrefIdx[%mod, %pref] !$= "")
	{
		%idx = $BpPrefIdx[%mod, %pref];

		$BpPref[%mod, %idx] = %data;
		$BpPrefDefault[%mod, %idx] = %def;
		$BpPrefValue[%mod, %idx] = %val;
		$BpPrefLast[%mod, %idx] = %val;
	}
	else
	{
		if($BpPrefs[%mod] $= "")
		{
			$BpPrefs[%mod] = 0;
			$BpPrefMod[$BpPrefMods] = %mod;

			$BpPrefMods++;
		}

		$BpPref[$BpPrefs] = %mod TAB $BpPrefs[%mod];
		$BpPrefs++;

		$BpPref[%mod, $BpPrefs[%mod]] = %data;
		$BpPrefDefault[%mod, $BpPrefs[%mod]] = %def;
		$BpPrefValue[%mod, $BpPrefs[%mod]] = %val;
		$BpPrefLast[%mod, $BpPrefs[%mod]] = %val;
		$BpPrefIdx[%mod, %pref] = $BpPrefs;

		$BpPrefs[%mod]++;
	}
}

function clientCmdBpPrefsDone(%host)
{
	$CBpIsHost = %host;
	if(!$CBpActive)
	{
		$CBpActive = true;

		BpCategoryList.clear();

		%cts = $BpPrefMods;
		for(%i = 0; %i < %cts; %i++)
		{
			%mod = $BpPrefMod[%i];

			BpCategoryList.addRow(%i, %mod);
		}

		BpCategoryList.sort(0, true);
		BpCategoryList.setSelectedRow(0);

		$CBpRtbPrefsBtn.command = "Canvas.pushDialog(BpManagerGui);";
	}
}

function BpManagerGui::onWake(%obj)
{
}

function BpCleanup()
{
	$CBpActive = false;
	$CBpIsHost = false;
	$CBpRtbPrefsBtn.command = $CBpRtbPrefsCmd;
	BpPrefContainer.deleteAll();
	BpCategoryList.clear();
}

function BpReset()
{
	deleteVariables("$Bp*");
	commandToServer('BpRequestPrefList', true);
}

function BpCategorySelect()
{
	if(!$CBpActive) return;
	
	BpPrefContainer.deleteAll();

	%idx = BpCategoryList.getSelectedId();
	%mod = $BpPrefMod[%idx];

	%entryHeight = 24;

	%lastCat = "";
	%cts = $BpPrefs[%mod];
	for(%i = 0; %i < %cts; %i++)
	{
		%data = $BpPref[%mod, %i];

		%name = getField(%data, 0);
		%pref = getField(%data, 1);
		%cat  = getField(%data, 2);
		%type = getField(%data, 3);
		%mod  = getField(%data, 4);
		// %rest = getField(%data, 5);
		%host = getField(%data, 6);
		// %call = getField(%data, 7);

		if(%host && !$CBpIsHost)
			continue;

		if(%cat !$= %lastCat)
		{
			%lastCat = %cat;

			%head = bpTmpHead.BpDuplicate();
			%head.position = "0 " @ %entryHeight * BpPrefContainer.getCount();
			%head.setName("bphead");

			%htitle = %head.findObjectByInternalName("title");
			%htitle.setValue("<just:center><font:impact:18><color:FFFFFF>" @ stripMLControlChars(BpStripCategory(%cat)));

			BpPrefContainer.add(%head);
		}

		%typeFW = firstWord(%type);
		%field = bpTmpField.BpDuplicate();
		%field.position = "0 " @ %entryHeight * BpPrefContainer.getCount();
		%field.setName("bpfield");

		%ftitle = %field.findObjectByInternalName("title");
		%ftitle.setValue(stripMLControlChars(%name));

		%freset = %field.findObjectByInternalName("reset").findObjectByInternalName("btn");
		%freset.command = "BpResetPref(\"" @ expandEscape(%mod) @ "\", " @ %i @ ");";

		if(%typeFW $= "bool")
		{
			%ctrl = bpTmpBool.findObjectByInternalName("content").BpDuplicate();

			%check = %ctrl.findObjectByInternalName("check");
			%check.setValue($BpPrefValue[%mod, %i]);
			%check.command = "BpSetPref(\"" @ expandEscape(%mod) @ "\", " @ %i @ ", " @ %check @ ".getValue());";
			
			%field.add(%ctrl);
		}
		else if(%typeFW $= "int" || %typeFW $= "float" || %typeFW $= "num")
		{
			%ctrl = bpTmpNum.findObjectByInternalName("content").BpDuplicate();

			%text = %ctrl.findObjectByInternalName("input");
			%text.setValue($BpPrefValue[%mod, %i]);
			
			%min = getWord(%type, 1);
			%max = getWord(%type, 2);

			%func = "BpFloatInput";

			if(%typeFW $= "int")
				%func = "BpIntInput";

			%text.command = %func @ "(\"" @ expandEscape(%min) @ "\", \"" @ expandEscape(%max) @"\", BpSetPref, \"" @ expandEscape(%mod) @ "\", " @ %i @ ");";
			
			%field.add(%ctrl);
		}
		else if(%typeFW $= "string")
		{
			%ctrl = bpTmpText.findObjectByInternalName("content").BpDuplicate();

			%text = %ctrl.findObjectByInternalName("input");
			%text.setValue($BpPrefValue[%mod, %i]);

			%text.maxLength = getWord(%type, 1);
			%text.command = "BpSetPref(\"" @ expandEscape(%mod) @ "\", " @ %i @ ", " @ %text @ ".getValue());";
			
			%field.add(%ctrl);
		}
		else if(%typeFW $= "list" || %typeFW $= "datablock")
		{
			%ctrl = bpTmpList.findObjectByInternalName("content").BpDuplicate();

			%value = $BpPrefValue[%mod, %i];
			%list = %ctrl.findObjectByInternalName("list");

			if(%typeFW $= "list")
			{
				%ct2 = getWordCount(%type);
				for(%j = 1; %j < %ct2; %j += 2)
				{
					%id = getWord(%type, %j);
					%val = getWord(%type, %j+1);

					%list.add(%id, %val);
				}
			}
			else
			{
				// todo: datablocks
				%list.sort();
			}
			
			%list.setSelected(%value);
			%list.command = "BpSetPref(\"" @ expandEscape(%mod) @ "\", " @ %i @ ", " @ %list @ ".getSelected());";

			%field.add(%ctrl);
		}
		else
		{
			error("BpCategorySelect() - invalid pref type " @ %type @ " for " @ %cat @ " - " @ %name);
			%field.delete();
		}

		$BpPrefField[%mod, %i] = %field.findObjectByInternalName("content");
		$BpPrefReset[%mod, %i] = %freset.getGroup();

		$BpPrefReset[%mod, %i].setVisible($BpPrefValue[%mod, %i] !$= $BpPrefDefault[%mod, %i]);

		BpPrefContainer.add(%field);
	}

	BpPrefContainer.AMG_FitContentsY(0);
}

function BpResetAllPrefs()
{
	if(!$CBpActive) return;

	commandToServer('RTB_defaultServerPrefs');
	BpRefreshPrefList();
}

function BpResetPref(%mod, %idx)
{
	%value = $BpPrefDefault[%mod, %idx];
	BpSetPref(%mod, %idx, %value);

	if(isObject($BpPrefField[%mod, %idx]))
	{
		%field = $BpPrefField[%mod, %idx].getObject(0);

		%cmd = %field.command;
		%field.command = "";

		%class = %field.getClassName();
		if(%class $= "GuiTextEditCtrl" || %class $= "GuiCheckBoxCtrl")
			%field.setValue(%value);
		else if(%class $= "GuiPopUpMenuCtrl")
			%field.setSelected(%value);

		%field.command = %cmd;
	}
}

function BpSetPref(%mod, %idx, %value)
{
	$BpPrefValue[%mod, %idx] = %value;

	if(isObject($BpPrefReset[%mod, %idx]))
		$BpPrefReset[%mod, %idx].setVisible(%value !$= $BpPrefDefault[%mod, %idx]);
}

function BpRefreshPrefList()
{
	BpCleanup();
	BpReset();
}

function BpConfirmPrefs()
{
	%cts = $BpPrefs;
	for(%i = 0; %i < %cts; %i++)
	{
		%p = $BpPref[%i];

		%mod = getField(%p, 0);
		%idx = getField(%p, 1);

		%val = $BpPrefValue[%mod, %idx];
		if(%val !$= $BpPrefLast[%mod, %idx])
		{
			commandToServer('BpSetPrefValue', %i, %val);
			$BpPrefLast[%mod, %idx] = %val;
		}
	}

	Canvas.popDialog(BpManagerGui);
}

function BpOpenFavoritesList()
{
	if(!$CBpActive) return;
	
	// todo
	echo("todo: open preference saves");
}

package BetterPrefsClient
{
	function disconnectedCleanup(%a)
	{
		deleteVariables("$Bp*");
		$CBpRtbPrefsBtn.command = $CBpRtbPrefsCmd;
		$CBpActive = false;
		$CBpIsHost = false;

		return Parent::disconnectedCleanup(%a);
	}

	function RTB_ServerControl::onWake(%obj)
	{
		if(!$CBpActive)
			commandToServer('BpRequestPrefList');

		return Parent::onWake(%obj);
	}
};
activatePackage(BetterPrefsClient);