// useful functions taken from advanced minigames

$CBpValidateDelay = 300;

function BpIntInput(%min, %max, %callback, %a, %b)
{
	if(isObject(%obj = $ThisControl))
	{
		cancel(%obj.validate);
		cancel(%obj.callback);
		%val = atoi(%obj.getValue());

		if(%min !$= "" && %max $= "" && %min > 0)
		{
			%max = %min;
			%min = 0;
		}
		else if(%min $= "" || %max $= "" || %min >= %max)
		{
			%max = 0;
			%min = 0;
		}

		if(%max > %min)
			%val = mClamp(%val, %min, %max);

		%obj.validate = %obj.schedule($CBpValidateDelay, setValue, %val);
		%obj.callback = schedule($CBpValidateDelay, %obj, %callback, %a, %b, %val, %obj);
	}
}

function BpFloatInput(%min, %max, %callback, %a, %b)
{
	if(isObject(%obj = $ThisControl))
	{
		cancel(%obj.validate);
		cancel(%obj.callback);
		%val = atof(%obj.getValue());

		if(%min !$= "" && %max $= "" && %min > 0)
		{
			%max = %min;
			%min = 0;
		}
		else if(%min $= "" || %max $= "" || %min >= %max)
		{
			%max = 0;
			%min = 0;
		}

		if(%max > %min)
			%val = mClampF(%val, %min, %max);

		%obj.validate = %obj.schedule($CBpValidateDelay, setValue, %val);
		%obj.callback = schedule($CBpValidateDelay, %obj, %callback, %a, %b, %val, %obj);
	}
}

function GuiControl::BpDuplicate(%obj)
{
	%obj = %obj.getId();

	%path = "config/client/amg_tmp.gui";
	%name = %obj.getName();
	%class = %obj.getClassName();
	%obj.setName(AMG_TEMP_ELEM @ %class);
	%obj.save(%path);
	%obj.setName(%name);

	AMG_SilentExec(%path);

	if(isObject(%ctrl = AMG_TEMP_ELEM @ %class))
	{
		%ctrl = %ctrl.getId();
		%ctrl.setName(%name);

		return %ctrl;
	}

	return -1;
}

function GuiControl::AMG_FitContentsY(%obj, %margin)
{
	%cts = %obj.getCount();
	%lowest = -1;
	for(%i = 0; %i < %cts; %i++)
	{
		%ctrl = %obj.getObject(%i);

		%pos = %ctrl.position;
		%ext = %ctrl.extent;

		%yBtm = getWord(%pos, 1) + getWord(%ext, 1);

		if(%yBtm > %lowest)
			%lowest = %yBtm;
	}

	%yMin = getWord(%obj.minExtent, 1);
	if(%lowest + %margin <= %yMin)
	{
		%obj.setExtent(getWord(%obj.extent, 0), %yMin);
		return %yMin;
	}
	else
	{
		%obj.setExtent(getWord(%obj.extent, 0), %lowest + %margin);
		return %lowest + %margin;
	}
}

function AMG_SilentExec(%path)
{
	if(!isFile(%path))
		return;
	
	%ext = fileExt(%path);

	if(%ext !$= ".cs" && %ext !$= ".gui" && %ext !$= ".mis")
		return;
	
	%file = new FileObject();

	if(!%file.openForRead(%path))
	{
		error("AMG_SilentExec() - couldn't read file " @ %path);
		return;
	}

	%str = "";
	while(!%file.isEOF())
		%str = trim(%str NL %file.readLine());

	eval(%str);
}